using System.Net; 
using System.Net.Sockets;

public class ch05_10
{
    public static void Main()
    {
        TcpListener tcpListener = new TcpListener(IPAddress.Any, 65512);
        tcpListener.Start();       

        System.Console.WriteLine("Waiting for connection...");

        while (true)
        {
            Socket socket = tcpListener.AcceptSocket();
            if (socket.Connected)
            {
                Client client = new Client(socket);
            }
        }
    }
}

class Client
{
    byte[] dataBuffer;
    Socket socket;
    NetworkStream networkStream;
    System.AsyncCallback readDelegate;
    System.AsyncCallback writeDelegate;

    public Client(Socket socket)
    {
        this.socket = socket;
        dataBuffer = new byte[512];
        networkStream = new NetworkStream(socket);

        System.Console.WriteLine("Connected to a client...");

        readDelegate = new System.AsyncCallback(this.OnRead);
        writeDelegate = new System.AsyncCallback(this.OnWrite);
        networkStream.BeginRead(dataBuffer, 0, dataBuffer.Length, readDelegate, null);
    }

    private void OnRead(System.IAsyncResult asyncResult)
    {
        int numberBytes = networkStream.EndRead(asyncResult);

        if (numberBytes > 0)
        {
            string outputString = System.Text.Encoding.ASCII.GetString(dataBuffer, 0, numberBytes - 2);
            System.Console.WriteLine("Read this text: \"{0}\".", outputString);
            networkStream.BeginWrite(dataBuffer, 0, numberBytes, writeDelegate, null);
        }
        else
        {
            System.Console.WriteLine("Read operation with this client finished...");
            networkStream.Close();
            networkStream = null;
            socket.Close();
            socket = null;
        }
    }

    private void OnWrite(System.IAsyncResult asyncResult)
    {
        networkStream.EndWrite(asyncResult);
        System.Console.WriteLine("Sent text back to client...");
        networkStream.BeginRead(dataBuffer, 0, dataBuffer.Length, readDelegate, null);
    }
}