   using System;
   using System.IO;
   using System.Runtime.Serialization;
   using System.Runtime.Serialization.Formatters.Binary;

   [Serializable]
   class ch05_14 : IDeserializationCallback
   {
      [NonSerialized] private int[] data;

      public static void Main()
      {
         System.Console.WriteLine("Creating an object...");
         ch05_14 obj = new ch05_14();

         ch05_14 deserializedObject = obj.Deserialize();
         deserializedObject.DisplayItems();
      }

      public ch05_14()
      {
         data = new int[3];
         data[0] = 1;
         data[1] = 2;
         data[2] = 3;
         Serialize();
      }

      private void DisplayItems()
      {
          System.Console.WriteLine("Displaying the object's items...");
          foreach (int value in data)
          {
              System.Console.WriteLine(value);
          }
      }

      private void Serialize()
      {
         System.Console.WriteLine("Serializing it...");
         FileStream output = new FileStream("ch05_14.out", FileMode.Create);
         BinaryFormatter formatter = new BinaryFormatter();
         formatter.Serialize(output, this);
         output.Close();
      }

      public ch05_14 Deserialize()
      {
         System.Console.WriteLine("Deserializing it...");
         FileStream input = new FileStream("ch05_14.out", FileMode.Open);
         BinaryFormatter formatter = new BinaryFormatter();
         return (ch05_14) formatter.Deserialize(input);
      }

      public virtual void OnDeserialization(Object obj)
      {
         System.Console.WriteLine("Recreating data...");
         data = new int[3];
         data[0] = 1;
         data[1] = 2;
         data[2] = 3;
      }
   }

