using System.Collections;

public class ch06_12
{
    static void Main()
    {
        CustomerList customerList = new CustomerList("Ralph", "Ed", 
            "Alice", "Trixie");

        foreach (string customer in customerList)
        {
            System.Console.WriteLine(customer);
        }
    }
}
                                    
public class CustomerList: IEnumerable
{
    private string[] customers;
    private int number = 0;

    public CustomerList(params string[] customerNames)
    {
        customers = new string[100]; 

        foreach (string name in customerNames)
        {
            customers[number++] = name;
        }
    }

    public string this[int index]
    {
        get
        {
            return customers[index];
        }
        set
        {
            customers[index] = value;
        }
    }

    public IEnumerator GetEnumerator()
    {
        return (IEnumerator) new CustomerListEnumerator(this);
    }

    private class CustomerListEnumerator : IEnumerator
    {
        private CustomerList customerList;
        private int index;

        public CustomerListEnumerator(CustomerList customerList)
        {
            this.customerList = customerList;
            index = -1;
        }

        public bool MoveNext()
        {
            if (index < customerList.number - 1){
                index++;
                return true;
            } 
            else {
                return false;
            }
        }

        public object Current
        {
            get
            {
                return(customerList[index]);
            }
        }

        public void Reset()
        {
            index = -1;
        }
    }
}
