using System.Collections;

public class ch06_14
{
    static void Main()
    {
        Customer[] customerArray = new Customer[4];

        customerArray[0] = new Customer("Ralph", "Smith");
        customerArray[1] = new Customer("Ed", "Franklin");
        customerArray[2] = new Customer("Alice", "Johnson");
        customerArray[3] = new Customer("Trixie", "Patterson");
         
        System.Console.WriteLine("The customers:");
        for (int loopIndex = 0; loopIndex < customerArray.Length; loopIndex++)
        {
            System.Console.Write("{0} ", customerArray[loopIndex]);
        }
        System.Console.WriteLine();
        System.Console.WriteLine();

        Customer.CustomerComparer comparer = Customer.GetComparer();
        comparer.useFirstName = false;
        System.Array.Sort(customerArray, comparer);

        System.Console.WriteLine("The sorted customers:");
        for (int loopIndex = 0; loopIndex < customerArray.Length; loopIndex++)
        {
            System.Console.Write("{0} ", customerArray[loopIndex]);
        }
        System.Console.WriteLine();
    }
}

public class Customer 
{
    private string firstName;
    private string lastName;

    public Customer(string firstName, string lastName)
    {
         this.firstName = firstName;
         this.lastName = lastName;
    }

    public override string ToString()
    {
         return firstName + " " + lastName;
    }

    public int CompareTo(object obj, bool useFirstName)
    {
         Customer customer = (Customer) obj;
         if (useFirstName){
             return this.firstName.CompareTo(customer.firstName);
         } else {
             return this.lastName.CompareTo(customer.lastName);
         }
    }

    public static CustomerComparer GetComparer()
    {
         return new Customer.CustomerComparer();
    }

    public class CustomerComparer : IComparer
    {
        public bool useFirstName = true;

        public int Compare(object object1, object object2)
        {
            Customer customer1 = (Customer) object1;
            Customer customer2 = (Customer) object2;
            return customer1.CompareTo(customer2, useFirstName);
        }
    }
}
