using System;
using System.Reflection;

[AttributeUsage(AttributeTargets.Class |
    AttributeTargets.Constructor |
    AttributeTargets.Field |
    AttributeTargets.Method |
    AttributeTargets.Property,
    AllowMultiple = true)]
public class Author : System.Attribute
{
    private string  privateText;
    private string  privateTime;
    private string  privateName;

    public Author(string name, string time)
    {
        privateName = name;
        privateTime = time;
    }

    public string Text
    {
        get
        {
            return privateText;
        }
        set
        {
            privateText = value;
        }
    }

    public string Time
    {
        get
        {
            return privateTime;
        }
    }

    public string Name
    {
        get
        {
            return privateName;
        }
    }
}

[Author("Cary Grant", "11/25/48")]
[Author("Grace Kelly", "11/25/48", Text="Hi Cary!")]
public class Displayer
{
    public void Display()
    {
        System.Console.WriteLine("No worries!");           
    }
}

public class ch14_02
{
    public static void Main()
    {
        Displayer displayer = new Displayer();
        displayer.Display();
    }        
}


