using System.Threading;

class ch15_02
{
    static void Main()
    {
        ch15_02 app = new ch15_02();

        app.StartThreads();
    }

    public void StartThreads()
    {
        Thread thread1 = new Thread(new ThreadStart(NoWorries));
        Thread thread2 = new Thread(new ThreadStart(NoProblems));
        Thread thread3 = new Thread(new ThreadStart(NoTroubles));

        thread1.Name = "Thread 1";
        thread2.Name = "Thread 2";
        thread3.Name = "Thread 3";

        thread1.Start();

        thread2.Start();
        Thread.Sleep(3);
        thread2.Abort();

        thread3.Start();
        thread3.Suspend();
        Thread.Sleep(10);
        thread3.Resume();

        thread1.Join();
        thread2.Join();
        thread3.Join();

        System.Console.WriteLine("All threads finished.");
    }

    public void NoWorries()
    {
        Thread.Sleep(10);
        try
        {
            for (int loopIndex =0; loopIndex < 15; loopIndex++)
            {
                System.Console.WriteLine("No Worries.");
            }
        }
        catch (ThreadAbortException)
        {
            System.Console.WriteLine("{0} was aborted.",
                Thread.CurrentThread.Name);
        }
        finally
        {
            System.Console.WriteLine("{0} is done.",
                Thread.CurrentThread.Name);
        }
    }

    public void NoProblems()
    {
        try
        {
            for (int loopIndex =0; loopIndex < 20; loopIndex++)
            {
                 System.Console.WriteLine("No Problems.");
            }
        }
        catch (ThreadAbortException)
        {
            System.Console.WriteLine("{0} was aborted.",
                Thread.CurrentThread.Name);
        }
        finally
        {
            System.Console.WriteLine("{0} is done.",
                Thread.CurrentThread.Name);
        }
    }

    public void NoTroubles()
    {
        try
        {
            for (int loopIndex =0; loopIndex < 15; loopIndex++)
            {
                 System.Console.WriteLine("No Troubles.");
            }
        }
        catch (ThreadAbortException)
        {
            System.Console.WriteLine("{0} was aborted.",
                Thread.CurrentThread.Name);
        }
        finally
        {
            System.Console.WriteLine("{0} is done.",
                Thread.CurrentThread.Name);
        }
    }
}

